# Class: Geolocation

## ol.Geolocation

Helper class for providing HTML5 Geolocation capabilities. The Geolocation API is used to locate a user's position.

Example:

    var geolocation = new ol.Geolocation();
    // take the projection to use from the map's view
    geolocation.bindTo('projection', map.getView());
    // listen to changes in position
    geolocation.on('change', function(evt) {
      window.console.log(geolocation.getPosition());
    });

#### new ol.Geolocation(opt_options) experimental

src/ol/geolocation.js, line 59

  Name | Type | Description
  --- | --- | ---
  `options` | optional Options.
  Name | Type | Description
  --- | --- | ---
  `tracking` | boolean | undefined | optional Start Tracking. Default is `false`.
  `trackingOptions` | GeolocationPositionOptions | undefined | optional Tracking options. See http://www.w3.org/TR/geolocation-API/#position_options_interface.
  `projection` | ol.proj.ProjectionLike | Projection.

  ##### Fires:

  - `beforepropertychange` (ol.ObjectEvent) experimental - Triggered before a property is changed.
  - `change` experimental - Triggered when the position changes.
  - `change:accuracy` (ol.ObjectEvent) experimental
  - `change:accuracygeometry` (ol.ObjectEvent) experimental
  - `change:altitude` (ol.ObjectEvent) experimental
  - `change:altitudeaccuracy` (ol.ObjectEvent) experimental
  - `change:heading` (ol.ObjectEvent) experimental
  - `change:position` (ol.ObjectEvent) experimental
  - `change:projection` (ol.ObjectEvent) experimental
  - `change:speed` (ol.ObjectEvent) experimental
  - `change:tracking` (ol.ObjectEvent) experimental
  - `change:trackingoptions` (ol.ObjectEvent) experimental
  - `propertychange` (ol.ObjectEvent) experimental - Triggered when a property is changed.

### Extends

- ol.Object

### Observable Properties

Name | Type | Settable | ol.ObjectEvent type | Description
--- | --- | --- | --- | ---
`accuracy` | number | undefined | no | `change:accuracy` | The accuracy of the position measurement in meters.
`accuracyGeometry` | ol.geom.Geometry | no | `change:accuracygeometry` | A geometry of the position accuracy.
`altitude` | number | undefined | no | `change:altitude` | The altitude of the position in meters above mean sea level.
`altitudeAccuracy` | number | undefined | no | `change:altitudeaccuracy` | The accuracy of the altitude measurement in meters.
`heading` | number | undefined | no | `change:heading` | The heading of the device in radians from north.
`position` | ol.Coordinate | undefined | no | `change:position` | The current position of the device reported in the current projection.
`projection` | ol.proj.Projection | undefined | yes | `change:projection` | The projection the position is reported in.
`speed` | number | undefined | no | `change:speed` | The instantaneous speed of the device in meters per second.
`tracking` | boolean | yes | `change:tracking` | Whether to track the device's position.
`trackingOptions` | GeolocationPositionOptions | undefined | yes | `change:trackingoptions` | PositionOptions as defined by the HTML5 Geolocation spec at http://www.w3.org/TR/geolocation-API/#position_options_interface

### Methods

#### bindTo(key, target, opt_targetKey){ol.ObjectAccessor} inherited experimental

src/ol/object.js, line 257

  The bindTo method allows you to set up a two-way binding between a `source` and `target` object. The method returns an ol.ObjectAccessor with a transform method that lets you transform values on the way from the source to the target and on the way back.

  For example, if you had two map views (sourceView and targetView) and you wanted the target view to have double the resolution of the source view, you could transform the resolution on the way to and from the target with the following:

      sourceView.bindTo('resolution', targetView)
        .transform(
          function(sourceResolution) {
            // from sourceView.resolution to targetView.resolution
            return 2 * sourceResolution;
          },
          function(targetResolution) {
            // from targetView.resolution to sourceView.resolution
            return targetResolution / 2;
          }
        );

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.
  `target` | ol.Object | Target.
  `targetKey` | string | optional Target key.

#### dispatchChangeEvent() inherited experimental

src/ol/observable.js, line 41

  Dispatches a `change` event.

  ##### Fires:

  - `change` experimental

#### get(key){*} inherited experimental

src/ol/object.js, line 314

  Gets a value.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.

  ##### Returns:

  Value.

#### getAccuracy(){number|undefined} experimental

src/ol/geolocation.js, line 197

  Get the accuracy of the position in meters.

  ##### Returns:

  The accuracy of the position measurement in meters.

#### getAccuracyGeometry(){ol.geom.Geometry} experimental

src/ol/geolocation.js, line 213

  Get a geometry of the position accuracy.

  ##### Returns:

  A geometry of the position accuracy.

#### getAltitude(){number|undefined} experimental

src/ol/geolocation.js, line 230

  Get the altitude associated with the position.

  ##### Returns:

  The altitude of the position in meters above mean sea level.

#### getAltitudeAccuracy(){number|undefined} experimental

src/ol/geolocation.js, line 247

  Get the altitude accuracy of the position.

  ##### Returns:

  The accuracy of the altitude measurement in meters.

#### getHeading(){number|undefined} experimental

src/ol/geolocation.js, line 263

  Get the heading as radians clockwise from North.

  ##### Returns:

  The heading of the device in radians from north.

#### getKeys(){Array.<string>} inherited experimental

src/ol/object.js, line 342

  Get a list of object property names.

  ##### Returns:

  List of property names.

#### getPosition(){ol.Coordinate|undefined} experimental

src/ol/geolocation.js, line 280

  Get the position of the device.

  ##### Returns:

  The current position of the device reported in the current projection.

#### getProjection(){ol.proj.Projection|undefined} experimental

src/ol/geolocation.js, line 297

  Get the projection associated with the position.

  ##### Returns:

  The projection the position is reported in.

#### getProperties(){Object.<string, *>} inherited experimental

src/ol/object.js, line 374

  Get an object of all property names and values.

  ##### Returns:

  Object.

#### getSpeed(){number|undefined} experimental

src/ol/geolocation.js, line 314

  Get the speed in meters per second.

  ##### Returns:

  The instantaneous speed of the device in meters per second.

#### getTracking(){boolean} experimental

src/ol/geolocation.js, line 330

  Are we tracking the user's position?

  ##### Returns:

  Whether to track the device's position.

#### getTrackingOptions(){GeolocationPositionOptions|undefined} experimental

src/ol/geolocation.js, line 349

  Get the tracking options.

  See:
    - http://www.w3.org/TR/geolocation-API/#position-options

  ##### Returns:

  PositionOptions as defined by the HTML5 Geolocation spec at http://www.w3.org/TR/geolocation-API/#position_options_interface

#### notify(key) inherited experimental

src/ol/object.js, line 394

  Notify all observers of a change on this property. This notifies both objects that are bound to the object's property as well as the object that it is bound to.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.

#### on(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 63

  Listen for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### once(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 76

  Listen once for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### set(key, value) inherited experimental

src/ol/object.js, line 425

  Sets a value.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.
  `value` | * | Value.

#### setProjection(projection) experimental

src/ol/geolocation.js, line 366

  Set the projection to use for transforming the coordinates.

  Name | Type | Description
  --- | --- | ---
  `projection` | ol.proj.Projection | The projection the position is reported in.

#### setTracking(tracking) experimental

src/ol/geolocation.js, line 381

  Enable/disable tracking.

  Name | Type | Description
  --- | --- | ---
  `tracking` | boolean | Whether to track the device's position.

#### setTrackingOptions(options) experimental

src/ol/geolocation.js, line 399

  Set the tracking options.

  Name | Type | Description
  --- | --- | ---
  `options` | GeolocationPositionOptions | PositionOptions as defined by the HTML5 Geolocation spec at http://www.w3.org/TR/geolocation-API/#position_options_interface

  See:
    - http://www.w3.org/TR/geolocation-API/#position-options

#### setValues(values) inherited experimental

src/ol/object.js, line 454

  Sets a collection of key-value pairs.

  Name | Type | Description
  --- | --- | ---
  `values` | Object.<string, *> | Values.

#### un(type, listener, opt_this) inherited experimental

src/ol/observable.js, line 88

  Unlisten for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

#### unbind(key) inherited experimental

src/ol/object.js, line 468

  Removes a binding. Unbinding will set the unbound property to the current value. The object will not be notified, as the value has not changed.

  Name | Type | Description
  --- | --- | ---
  `key` | string | Key name.

#### unbindAll() inherited experimental

src/ol/object.js, line 492

  Removes all bindings.

#### unByKey(key) inherited experimental

src/ol/observable.js, line 98

  Removes an event listener using the key returned by `on()` or `once()`.

  Name | Type | Description
  --- | --- | ---
  `key` | goog.events.Key | Key.